



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>NCE损失(Noise-Constrastive Estimation Loss)</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">NCE损失(Noise-Constrastive Estimation Loss)</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-01 09:48:49 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h3>1.算法概述</h3>
<p>假设X是从真实的数据（或语料库）中抽取的样本,其服从一个相对可参考的概率密度函数P(d),噪音样本Y服从概率密度函数为P(n)，噪音对比估计(NCE)就是通过学习一个分类器把这两类样本区别开来，并能从模型中学到数据的属性。</p>
<p>模型原始论文：<a href="http://www.jmlr.org/proceedings/papers/v9/gutmann10a/gutmann10a.pdf" rel="external nofollow noreferrer">Noise-contrastive estimation: A new estimation principle for unnormalized statistical models</a><br />
tensorflow引用：<a href="https://www.tensorflow.org/extras/candidate_sampling.pdf" rel="external nofollow noreferrer">Candidate Sampling Algorithms Reference</a></p>
<h3>2.算法要点与推导</h3>
<h4>2.1损失函数定义：</h4>
<p>\[<br />
\text{让$U=X\bigcup Y={u1,u2,⋯,u_{T_d}+u_{T_n}}$，其中$T_d$为数据样本个数，$T_n$为噪音分布的样本个数。那么我们认为$u_t$服从(0-1)分布，给每个$u_t$一个标签$C_t$，则}<br />
\]</p>
<p>\[<br />
C_t=<br />
\begin{cases}<br />
    1,  &amp; \text{if $u_t \in X$} \\<br />
    0, &amp; \text{if $u_t \in Y$}<br />
    \end{cases}<br />
\]</p>
<p>\[<br />
\text{由于$p_d$未知，我们让$p(⋅|C=1)=p_m(.;θ)$，我们假设存在一个$\theta^*$}<br />
\text{使得$p_d(.)=p_m(.;\theta^*)$，那么，就可以认为经验分布$p_d(.)$为参数分布簇$p_m(.;θ)$中的一员。}<br />
\]<br />
给定以上定义，我们得到：</p>
<p>\[<br />
\begin{cases}<br />
    p(u|C=1)=p_m(u;\theta) ,&amp; \text{data}  \\<br />
    p(u|C=0)=p_n(u) ,&amp; \text{noise}<br />
    \end{cases}<br />
\]<br />
这里时间有限，中间推到步骤先略过。最终得到损失函数公式如下：</p>
<p>\[<br />
L(θ)=Σ^{T_d+T_n}_{t=1}[C_tlnP(C_t=1|u_t;\theta)+(1-C_t)lnP(C_t=0|u_t)] =Σ^{T_d}_{t=1}ln[h(x_t;θ)]+Σ^{Tn}_{t=1}ln[1-h(y_t;θ)]<br />
\]<br />
注意到，如果给式（9）加上个负号就成为了交叉熵函数了。从结果可以看出，我们进行的无监督学习的密度估计可由监督学习算法logistic regression来学习，这就是监督学习与无监督学习的联系。</p>
<h3>3.算法特性及优缺点</h3>
<h3>4.实现和具体例子</h3>
<p><a href="https://blog.csdn.net/littlely_ll/article/details/79252064" rel="external nofollow noreferrer">噪音对比估计（NCE）</a><br />
<a href="https://github.com/Tongzhenguo/Python-Project/blob/master/ctr_model/nce_loss.py" rel="external nofollow noreferrer">tensorflow tf.nn.nce_loss()源代码学习</a></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/0qwm47r8.html">Activity之间数据传递（一）（简单传递，数据包Bundle，传递对象）</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8kekr78.html">delphi项目中的modelsupport文件夹</a>
		</li>
						<li><a href="https://www.batexi.com/a/49go207q.html">mac  免密码登陆服务器</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xvm1n9.html">C结构体之位域（位段）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ok7yg19.html">Android 混淆文件project&period;properties和proguard-project&period;txt</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdemr479.html">Oracle EBS-SQL &lpar;PO-4&rpar;&colon;检查采购订单明细&period;sql</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn136n28.html">hdu 5590 ZYB&amp;&num;39&semi;s Biology</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn13p3x8.html">QF&mdash;&mdash;网络之知识碎片</a>
		</li>
						<li><a href="https://www.batexi.com/a/8meex32q.html">&lbrack;leetcode&rsqb; Combination Sum and Combination SumII</a>
		</li>
						<li><a href="https://www.batexi.com/a/96p0l0y8.html">javaproject积累&mdash;&mdash;java 反射 invoke</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxklx2e8.html">mysql的登录和备份</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ojr0gpq.html">Python装饰器模式学习总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwjgd5k8.html">ImageMagick简介、GraphicsMagick、命令行使用示例</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxddnlv9.html">3&period;11formdata的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwv40p38.html">MySQL 5&period;7&period;9版本sql&lowbar;mode&equals;only&lowbar;full&lowbar;group&lowbar;by</a>
		</li>
						<li><a href="https://www.batexi.com/a/95gnw1mq.html">TCP服务器&sol;客户端代码示例</a>
		</li>
						<li><a href="https://www.batexi.com/a/qll7vkkq.html">Centos7&period;2下OpenVPN 环境完整部署记录</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e4p50m9.html">29-hadoop-使用phtonenix工具&amp;amp&semi;分页&amp;amp&semi;数据导入</a>
		</li>
						<li><a href="https://www.batexi.com/a/9ppp3vz9.html">iis7&period;5 发布mvc出错的解决办法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvedgko9.html">Android开发之改动屏幕方向</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qlj41w69.html">Spring Boot使用Maven打包替换资源文件占位符</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pdrpoz9.html">win10 桌面设置为远程桌面</a>
			</li>
						<li><a href="https://www.batexi.com/a/93yzd3w8.html">我的第一个python web开发框架（40）&mdash;&mdash;后台日志与异常处理</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2j4m6o8.html">UI自动化之日志</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlj4nde9.html">应用wavesurfer&period;js绘制音频波形图小白极速上手总结</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdp2o47q.html">Linux新手随手笔记1&period;5</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxkv5k08.html">CentOS7 升级 gvim 到 8&period;x 版本</a>
			</li>
						<li><a href="https://www.batexi.com/a/90mgpdo8.html">SCOI2019酱油记</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rgx1p78.html">【原创】从Rest到Graphql</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv1lk5jq.html">linq中如何在join中指定多个条件</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
